c----------------------------------------------------------------------c
c                                                                      c
c                        Programma   2 G R S                           c
c                                                                      c
c                    2-Groups Reactor Simulation                       c
c                                                                      c
c                     F.Moretti - Novembre 1999                        c
c                                                                      c
c                (realizzato sulla base del programma                  c
c                 T P R S ,per analoga simulazione ad                  c
c                 un gruppo, dell'Ing. W.Ambrosini)                    c
c                                                                      c
c----------------------------------------------------------------------c
c
      program core2g
      implicit double precision (a-h,o-z)
      character*80 riga
c
      parameter (m = 101)
      common /generl/ h,aleng,rcore,rrefl,omega,n,method,istvid
      common/nuclea/diff(m,m,2),sigma(m,m,2),anisif(m,m,2),
     &              source(m,m,2),s12(m,m)
      common /flux/ phi(0:m,0:m,2),oldphi(0:m,0:m,2),akeff
      common /winds/ ce(m,m,2),cw(m,m,2),cn(m,m,2),cs(m,m,2),co(m,m,2)
      dimension class(m,m)
c
      open (unit=5,file='core.dat')
      open (unit=6,file='core.out')
      open (unit=7,file='core.pla')
      open (unit=8,file='core.txt')
c
c   lettura dei dati generali
c
      read(5,100) riga
      read(5,*) aleng,rcore,rrefl,n,method,omega1,omega2
c
c   primo processamento per ottenere costanti di interesse
c
      h = aleng / dfloat (n)
      halfal = 0.5d00 * aleng
      halfh = 0.5d00 * h
      pi = 4.d00 * datan (1.d00)
c
c   lettura delle costanti nucleari del nocciolo
c
      read(5,100) riga
      read(5,*) dcore1,sicor1,anisi1,s12cor,
     &          dcore2,sicor2,anisi2
c
c   lettura delle costanti nucleari del riflettore
c
      read(5,100)
      read(5,*) drefl1,siref1,s12ref,drefl2,siref2
c
c   opzione di stampa a video
c
      write(*,*) ' Stampa a video ? (1=si; 0=no) '
      read(*,*) istvid
c
c   assegnazione delle costanti nucleari nei nodi
c
         sorg1 = 1.d13
         sum = 0
c
      do 10 i = 1,n
      xi = h * dfloat(i) - halfh
      deltxi = xi - halfal
c
      do 10 j = 1,n
      yj = h * dfloat(j) - halfh
      deltyj = yj - halfal
c
      radius = dsqrt ( deltxi * deltxi + deltyj * deltyj )
c
c  nodi del nocciolo
         if(radius.le.rcore) then
         diff(i,j,1) = dcore1
         diff(i,j,2) = dcore2
         sigma(i,j,1) = sicor1
         sigma(i,j,2) = sicor2
         anisif(i,j,1) = anisi1
         anisif(i,j,2) = anisi2
         s12(i,j) = s12cor
         ratr = radius / rcore
         class(i,j) = 2.d00
c
c   Impostazione della sorgente di tentativo (solo primo gruppo: per il 
c   secondo si usa il flusso calcolato con la prima equazione)
c
         source(i,j,1) = sorg1 * dcos ( 0.5d00 * pi * ratr )
         sum = sum + source(i,j,1)
c
c  nodi del riflettore
         elseif(radius.le.rrefl) then
         diff(i,j,1) = drefl1
	 diff(i,j,2) = drefl2
         sigma(i,j,1) = siref1
	 sigma(i,j,2) = siref2
         s12(i,j) = s12ref
         source(i,j,1) = 0.d00
	 source(i,j,2) = 0.d00
         class(i,j) = 1.d00
c
c  nodi esterni
         else
         diff(i,j,1) = 1.d05
	 diff(i,j,2) = 1.d05
         sigma(i,j,1) = 1.d05
	 sigma(i,j,2) = 1.d05
         s12(i,j) = 0
         source(i,j,1) = 0.d00
	 source(i,j,2) = 0.d00
         class(i,j) = 0.d00
         endif
c
   10 continue
c
c   assegnazione delle costanti in nodi particolari (npart > 0)
c
      read(5,100) riga
      read(5,*) npart
c
         if(npart.gt.0) then
         read(5,100) riga
         do 20 ipart = 1,npart
         read(5,*) ip,jp,diff(ip,jp,1),sigma(ip,jp,1),anisif(ip,jp,1),
     &        diff(ip,jp,2),sigma(ip,jp,2),anisif(ip,jp,2),s12(ip,jp)
         class(ip,jp) = 3.d00
   20    continue
         endif
c
c   costruzione dei coefficienti dell'equazione della diffusione
c
      do 30 l = 1,2
      do 30 i = 1,n
      do 30 j = 1,n
c
         if(i.eq.1) then
         cw(i,j,l) = 2.d00 * diff(i,j,l)
         else
         cw(i,j,l) = 2.d00 * diff(i,j,l) * diff(i-1,j,l)
     &                   / ( diff(i,j,l) + diff(i-1,j,l) )
         endif
c
         if(i.eq.n) then
         ce(i,j,l) = 2.d00 * diff(i,j,l)
         else
         ce(i,j,l) = 2.d00 * diff(i,j,l) * diff(i+1,j,l)
     &                   / ( diff(i,j,l) + diff(i+1,j,l) )
         endif
c
         if(j.eq.1) then
         cs(i,j,l) = 2.d00 * diff(i,j,l)
         else
         cs(i,j,l) = 2.d00 * diff(i,j,l) * diff(i,j-1,l)
     &                   / ( diff(i,j,l) + diff(i,j-1,l) )
         endif
c
         if(j.eq.n) then
         cn(i,j,l) = 2.d00 * diff(i,j,l)
         else
         cn(i,j,l) = 2.d00 * diff(i,j,l) * diff(i,j+1,l)
     &                   / ( diff(i,j,l) + diff(i,j+1,l) )
         endif
c
      co(i,j,l) = ce(i,j,l) + cw(i,j,l) + cn(i,j,l) + cs(i,j,l)
     &                  + h * h * sigma(i,j,l)
c
   30 continue
c
c   ************ITERAZIONI ESTERNE********************
c
      call gettim(ihr,imin,isec,icent)
      time0 = 3600.d00 * ihr + 60.d00 * imin + isec + 0.01d00 * icent
c
c   fisso k eff. di tentativo e do' il via alle iterazioni
c
      akeff = 1.d00
      do 50 itext = 1,100000
      oldak = akeff
      oldsum = sum
c
c   risoluzione equazione del primo gruppo con il metodo prescelto
c
      l = 1
      omega = omega1 
      if(method.eq.1) call jacobi (iter,rspect,itext,l)
      rspct1 = rspect
      if(method.eq.2) call gseid (iter,itext,l)
      if(method.eq.3) call sor (iter,itext,l)
      if(method.eq.4) call lor (iter,itext,l)
c
      if (itext.eq.1) maxit1 = iter
c
c   preparo sorgente secondo gruppo (utilizzando il flusso del primo
c   gruppo gia' aggiornato);quindi risolvo la seconda equazione
c
      do 35 i = 1,n
      do 35 j = 1,n
      source(i,j,2) = s12(i,j) * phi(i,j,1)
   35 continue   
      l = 2
      omega = omega2  
      if(method.eq.1) call jacobi (iter,rspect,itext,l)
      rspct2 = rspect
      if(method.eq.2) call gseid (iter,itext,l)
      if(method.eq.3) call sor (iter,itext,l)
      if(method.eq.4) call lor (iter,itext,l)
c
      if (itext.eq.1) maxit2 = iter
c
c   Aggiorno sorgenti e calcolo sorgenti totali
      sum = 0.d00
      do 40 i = 1,n
      do 40 j = 1,n
      s1 = anisif(i,j,1) * phi(i,j,1)
      s2 = anisif(i,j,2) * phi(i,j,2)
      source(i,j,1) = s1 + s2
      sum = sum + source(i,j,1)
   40 continue
c
c   Aggiorno k effettivo (formula generazionale)
c
      akeff = oldak * sum / oldsum
c
         if(istvid.eq.1) then
         write(*,120) itext,akeff
         endif
      write(6,120) itext,akeff
c
      if(dabs(akeff-oldak).lt.1.d-7) goto 55
   50 continue
   55 continue
c
      call gettim(ihr,imin,isec,icent)
      time1 = 3600.d00 * ihr + 60.d00 * imin + isec + 0.01d00 * icent
      tcpu = time1 - time0
c
c   scrittura dei valori del flusso
c                                  
      totpow = 0.d00
      powmax = 0.d00
      phimd1 = 0.d00
      phimd2 = 0.d00
      sumsf1 = 0.d00
      sumsf2 = 0.d00
      do 60 i = 1,n
      xi = h * dfloat(i) - halfh
      do 60 j = 1,n
      yj = h * dfloat(j) - halfh
c
      sumsf1 = sumsf1 + anisif(i,j,1)
      sumsf2 = sumsf2 + anisif(i,j,2)
      phisf1= phi(i,j,1) * anisif(i,j,1)
      phisf2= phi(i,j,2) * anisif(i,j,2)
      pow = (phisf1 + phisf2) / ( 2.5d00 * 3.1e10 )
      phimd1 = phimd1 + phisf1
      phimd2 = phimd2 + phisf2
      totpow = totpow + pow * h * h * 365.76d00
      if(powmax.lt.pow) powmax = pow
c
      write(7,160) xi,yj,class(i,j)
      write(8,110) xi,yj,phi(i,j,1),phi(i,j,2)
   60 continue
      phimd1 = phimd1 / sumsf1
      phimd2 = phimd2 / sumsf2
      spcrat = phimd1 / phimd2
      powavg = totpow / ( pi * rcore * rcore * 365.76d00 )
      fattpc = powmax / powavg
      react = ( akeff - 1.d00 ) / akeff
c
         if(istvid.eq.1) then
         write(*,170) react
         write(*,180) totpow
         write(*,190) phimd1
         write(*,195) phimd2
         write(*,196) spcrat
         write(*,140) fattpc
         write(*,150) tcpu
         write(*,115) maxit1
         write(*,116) maxit2
         endif
c
         write(6,170) react
         write(6,180) totpow
         write(6,190) phimd1
         write(6,195) phimd2
         write(6,196) spcrat
         write(6,140) fattpc
         write(6,150) tcpu
         write(6,115) maxit1
         write(6,116) maxit2
c
          if(method.eq.1) then
          omopt1 = 2.d00 / ( 1.d00+dsqrt( 1.d00-rspct1*rspct1))
          omopt2 = 2.d00 / ( 1.d00+dsqrt(1.d00-rspct2*rspct2))
               if(istvid.eq.1) then
               write(*,130) rspct1
               write(*,131) rspct2 
               write(*,135) omopt1
               write(*,136) omopt2
               endif
          write(6,130) rspct1
          write(6,131) rspct2 
          write(6,135) omopt1
          write(6,136) omopt2
          endif
c
      stop
  100 format (a80)
  110 format (4(1x,e14.7))
  115 format (/,1x,' Numero massimo di iterazioni interne (1)',i5)
  116 format (1x,' Numero massimo di iterazioni interne (2)',i5)
  120 format (/,1x,' Iterazione Esterna n.',i5,'   keff = ',f12.9)
  121 format (/,1x,' N. Iterazioni Esterne = ',i5,' Keff = ',f12.9)
  130 format (1x,' Raggio Spettrale Jacobi (1)= ',f12.9)
  131 format (1x,' Raggio Spettrale Jacobi (2)= ',f12.9)
  135 format (1x,' Parametro Omega Ottimale (1)= ',f12.9)
  136 format (1x,' Parametro Omega Ottimale (2)= ',f12.9)
  140 format (1x,' Fattore di Picco Rad.  = ',f12.9)
  150 format (/,1x,' Tempo di Esecuzione = ',f7.2,' s ')
  160 format (3(1x,e14.7))
  170 format (/,1x,' Reattivit = ',f12.9)
  180 format (1x,' Potenza Termica Totale = ',1pe14.7,' W ')
  190 format (1x,' Flusso Medio (1)= ',1pe14.7,' n/(cm2.s)')
  195 format (1x,' Flusso Medio (2)= ',1pe14.7,' n/(cm2.s)')
  196 format (1x,' Rapporto spettrale     = ',f12.9)
      end
c
c----------------------------------------------------------------------c
c                                                                      c
c     Soluzione delle Equazioni della Diffusione con Jacobi            c
c                                                                      c
c----------------------------------------------------------------------c
      subroutine jacobi (iter,rspect,itext,l)
      implicit double precision (a-h,o-z)
c
      parameter (m = 101)
      common /generl/ h,aleng,rcore,rrefl,omega,n,method,istvid
      common/nuclea/diff(m,m,2),sigma(m,m,2),anisif(m,m,2),
     &              source(m,m,2),s12(m,m)
      common /flux/ phi(0:m,0:m,2),oldphi(0:m,0:m,2),akeff
      common /winds/ ce(m,m,2),cw(m,m,2),cn(m,m,2),cs(m,m,2),co(m,m,2)
c
c   assegnazione dell'approssimazione iniziale
c
      np1 = n + 1
      h2 = h * h
      do 10 i = 0,np1
      do 10 j = 0,np1
c
       if(itext.eq.1) then
         if( (i.eq.0).or.(j.eq.0).or.(i.eq.np1).or.(j.eq.np1) ) then
         phi(i,j,l) = 0.d00
         oldphi(i,j,l) = 0.d00
         else
         if (l.eq.1) then
            phi(i,j,l) = (h2 * source(i,j,l) / co(i,j,l))/ akeff
         else
            phi(i,j,l) = h2 * source(i,j,l) / co(i,j,l)
         endif
         oldphi(i,j,l) = phi(i,j,l)
         endif
       else
       oldphi(i,j,l) = phi(i,j,l)
       endif
c
   10 continue
c
      oldel2 = 1.d00
      do 30 iter = 1,10000000
c
      ratmax = 0.d00
      del2su = 0.d00
c
      do 20 j = 1,n
      do 20 i = 1,n
      tm = ce(i,j,l) * oldphi(i+1,j,l) + cn(i,j,l) * oldphi(i,j+1,l)
     &   + cw(i,j,l) * oldphi(i-1,j,l) + cs(i,j,l) * oldphi(i,j-1,l)
c
      if (l.eq.1) then
          phi(i,j,l) = ( tm + h2 * source(i,j,l) / akeff ) / co(i,j,l)
      else
          phi(i,j,l) = ( tm + h2 * source(i,j,l)) / co(i,j,l)
      endif
c
      delphi = phi(i,j,l) - oldphi(i,j,l)
      del2su = del2su + delphi * delphi
c     ratio = dabs (delphi) / ( phi(i,j,l) + 1.d-10 )
      ratio = dabs (delphi)
      if(ratio.gt.ratmax) ratmax = ratio
c
   20 continue
c
      do 25 i = 1,n
      do 25 j = 1,n
      oldphi(i,j,l) = phi(i,j,l)
   25 continue
c
      rspect = dsqrt ( del2su / oldel2 )
      oldel2 = del2su
c
      if((ratmax.lt.1.d00).and.(iter.ne.1)) goto 35
c
c      if(istvid.eq.1) write(*,101) iter,ratmax
c      write(6,101) iter,ratmax
   30 continue
      write(6,100)
c
   35 continue
      return
  100 format (/,1x,'<<<<< Attenzione Problemi di Convergenza >>>>>')
  101 format (' Iterazione Interna Jacobi n. ',i6,
     & ' Max. Errore = ',e14.7)
      end
c
c----------------------------------------------------------------------c
c                                                                      c
c     Soluzione delle Equazioni della Diffusione con Gauss-Seidel      c
c                                                                      c
c----------------------------------------------------------------------c
c
      subroutine gseid (iter,itext,l)
      implicit double precision (a-h,o-z)
c
      parameter (m = 101)
      common /generl/ h,aleng,rcore,rrefl,omega,n,method,istvid
      common/nuclea/diff(m,m,2),sigma(m,m,2),anisif(m,m,2),
     &              source(m,m,2),s12(m,m)
      common /flux/ phi(0:m,0:m,2),oldphi(0:m,0:m,2),akeff
      common /winds/ ce(m,m,2),cw(m,m,2),cn(m,m,2),cs(m,m,2),co(m,m,2)
c
c   assegnazione dell'approssimazione iniziale
c
      np1 = n + 1
      h2 = h * h
      do 10 i = 0,np1
      do 10 j = 0,np1
c
       if(itext.eq.1) then
         if( (i.eq.0).or.(j.eq.0).or.(i.eq.np1).or.(j.eq.np1) ) then
         phi(i,j,l) = 0.d00
         oldphi(i,j,l) = 0.d00
         else
         if (l.eq.1) then
            phi(i,j,l) = (h2 * source(i,j,l) / co(i,j,l))/ akeff
         else
            phi(i,j,l) = h2 * source(i,j,l) / co(i,j,l)
         endif
         oldphi(i,j,l) = phi(i,j,l)
         endif
       else
       oldphi(i,j,l) = phi(i,j,l)
       endif
c
   10 continue
c
      do 30 iter = 1,10000000
c
      ratmax = 0.d00
c
      do 20 j = 1,n
      do 20 i = 1,n
      tm = ce(i,j,l) * phi(i+1,j,l) + cn(i,j,l) * phi(i,j+1,l)
      tmp1 = cw(i,j,l) * phi(i-1,j,l) + cs(i,j,l) * phi(i,j-1,l)
c
      if (l.eq.1) then
      phi(i,j,l) = ( tm+tmp1+ h2 * source(i,j,l)/ akeff )/co(i,j,l)
      else
      phi(i,j,l) = ( tm+tmp1+ h2 * source(i,j,l) )/co(i,j,l)
      endif 
c
      delphi = phi(i,j,l) - oldphi(i,j,l)
c     ratio = dabs (delphi) / ( phi(i,j,l) + 1.d-10 )
      ratio = dabs (delphi)
      if(ratio.gt.ratmax) ratmax = ratio
c
      oldphi(i,j,l) = phi(i,j,l)
c
   20 continue
c
      if((ratmax.lt.1.d00).and.(iter.ne.1)) goto 35
c
c      if(istvid.eq.1) write(*,101) iter,ratmax
c      write(6,101) iter,ratmax
   30 continue
      write(6,100)
c
   35 continue
      return
  100 format (/,1x,'<<<<< Attenzione Problemi di Convergenza >>>>>')
  101 format (' Iterazione Interna GS n. ',i6,
     & ' Max. Errore = ',e14.7)
      end
c----------------------------------------------------------------------c
c                                                                      c
c     Soluzione delle Equazioni della Diffusione con SOR               c
c                                                                      c
c----------------------------------------------------------------------c
      subroutine sor (iter,itext,l)
      implicit double precision (a-h,o-z)
c
      parameter (m = 101)
      common /generl/ h,aleng,rcore,rrefl,omega,n,method,istvid
      common/nuclea/diff(m,m,2),sigma(m,m,2),anisif(m,m,2),
     &              source(m,m,2),s12(m,m)
      common /flux/ phi(0:m,0:m,2),oldphi(0:m,0:m,2),akeff
      common /winds/ ce(m,m,2),cw(m,m,2),cn(m,m,2),cs(m,m,2),co(m,m,2)
c
c   assegnazione dell'approssimazione iniziale
c
      np1 = n + 1
      h2 = h * h
      do 10 i = 0,np1
      do 10 j = 0,np1
c
       if(itext.eq.1) then
         if( (i.eq.0).or.(j.eq.0).or.(i.eq.np1).or.(j.eq.np1) ) then
         phi(i,j,l) = 0.d00
         oldphi(i,j,l) = 0.d00
         else
              if (l.eq.1) then
                   phi(i,j,l) = h2 * source(i,j,l) / co(i,j,l) / akeff
              else
                   phi(i,j,l) = h2 * source(i,j,l) / co(i,j,l)
              endif
         oldphi(i,j,l) = phi(i,j,l)
         endif
       else
       oldphi(i,j,l) = phi(i,j,l)
       endif
c
   10 continue
c
      do 30 iter = 1,10000000
c
      ratmax = 0.d00
c
      do 20 j = 1,n
      do 20 i = 1,n
      tm = ce(i,j,l) * phi(i+1,j,l) + cn(i,j,l) * phi(i,j+1,l)
      tmp1 = cw(i,j,l) * phi(i-1,j,l) + cs(i,j,l) * phi(i,j-1,l)
c
      if (l.eq.1) then
          phi(i,j,l)=(tm+tmp1+h2*source(i,j,l)/akeff)/co(i,j,l)
      else
          phi(i,j,l)=(tm+tmp1+h2*source(i,j,l))/co(i,j,l)
      endif
c
c   sovrarilassamento
c
      phi(i,j,l)=(phi(i,j,l)-oldphi(i,j,l))*omega+oldphi(i,j,l)
c
      delphi = phi(i,j,l) - oldphi(i,j,l)
c     ratio = dabs (delphi) / ( phi(i,j,l) + 1.d-10 )
      ratio = dabs (delphi)
      if(ratio.gt.ratmax) ratmax = ratio
c
      oldphi(i,j,l) = phi(i,j,l)
c
   20 continue
c
      if((ratmax.lt.1.d00).and.(iter.ne.1)) goto 35
c
c      if(istvid.eq.1) write(*,101) iter,ratmax
c      write(6,101) iter,ratmax
   30 continue
      write(6,100)
c
   35 continue
      return
  100 format (/,1x,'<<<<< Attenzione Problemi di Convergenza >>>>>')
  101 format (' Iterazione Interna SOR n. ',i6,
     & ' Max. Errore = ',e14.7)
      end
c----------------------------------------------------------------------c
c                                                                      c
c     Soluzione delle Equazioni della Diffusione con LOR               c
c                                                                      c
c----------------------------------------------------------------------c
      subroutine lor (iter,itext,l)
      implicit double precision (a-h,o-z)
c
      parameter (m = 101)
      common /generl/ h,aleng,rcore,rrefl,omega,n,method,istvid
      common/nuclea/diff(m,m,2),sigma(m,m,2),anisif(m,m,2),
     &              source(m,m,2),s12(m,m)
      common /flux/ phi(0:m,0:m,2),oldphi(0:m,0:m,2),akeff
      common /winds/ ce(m,m,2),cw(m,m,2),cn(m,m,2),cs(m,m,2),co(m,m,2)
c
      dimension a(m),b(m),c(m),d(m),v(m),alef(m),bet(m)
c
c   assegnazione dell'approssimazione iniziale
c
      np1 = n + 1
      h2 = h * h
      do 10 i = 0,np1
      do 10 j = 0,np1
c
       if(itext.eq.1) then
         if( (i.eq.0).or.(j.eq.0).or.(i.eq.np1).or.(j.eq.np1) ) then
         phi(i,j,l) = 0.d00
         oldphi(i,j,l) = 0.d00
         else
            if (l.eq.1) then
               phi(i,j,l) = h2 * source(i,j,l) / co(i,j,l) / akeff
            else
               phi(i,j,l) = h2 * source(i,j,l) / co(i,j,l)
            endif
         oldphi(i,j,l) = phi(i,j,l)
         endif
       else
       oldphi(i,j,l) = phi(i,j,l)
       endif
c
   10 continue
c
      do 40 iter = 1,10000000
c
      ratmax = 0.d00
c
c  ciclo sull'indice che definisce le linee orizzontali
c
      do 30 j = 1,n
c
c  assegnazione dei coefficienti della matrice tridiagonale di linea
c
      do 20 i = 1,n
      a(i) = - cw(i,j,l)
      b(i) = co(i,j,l)
      c(i) = - ce(i,j,l)
      if (l.eq.1) then
      d(i) = omega * ( h2 * source(i,j,l) / akeff
     & + cs(i,j,l) * phi(i,j-1,l) + cn(i,j,l) * phi(i,j+1,l) )
      else
      d(i) = omega * ( h2 * source(i,j,l)
     & + cs(i,j,l) * phi(i,j-1,l) + cn(i,j,l) * phi(i,j+1,l) )
      endif
      d(i) = d(i)+(1.d00 - omega)*( - cw(i,j,l) * phi(i-1,j,l)
     &   + co(i,j,l) * phi(i,j,l) - ce(i,j,l) * phi(i+1,j,l) )
   20 continue
c
c  soluzione del sistema tridiagonale
c
      call tdma (a,b,c,d,v,alef,bet,n,m)
c
c  assegnazione dei valori del flusso sulla linea j = costante
c  e valutazione dell'errore massimo
c
      do 25 i = 1,n
      oldphi(i,j,l) = phi(i,j,l)
      phi(i,j,l) = v(i)
c
      delphi = phi(i,j,l) - oldphi(i,j,l)
c     ratio = dabs (delphi) / ( phi(i,j,l) + 1.d-10 )
      ratio = dabs (delphi)
      if(ratio.gt.ratmax) ratmax = ratio
   25 continue
c
   30 continue
c
      if((ratmax.lt.1.d00).and.(iter.ne.1)) goto 45
c
c      if(istvid.eq.1) write(*,101) iter,ratmax
c      write(6,101) iter,ratmax
   40 continue
      write(6,100)
c
   45 continue
      return
  100 format (/,1x,'<<<<< Attenzione Problemi di Convergenza >>>>>')
  101 format (' Iterazione Interna LOR n. ',i6,
     & ' Max. Errore = ',e14.7)
      end
c----------------------------------------------------------------------c
c                                                                      c
c   Soluzione di Sistemi Tridiagonali con l'Algoritmo di Thomas        c
c                                                                      c
c----------------------------------------------------------------------c
      subroutine tdma (a,b,c,d,v,alef,bet,n,ld)
      implicit double precision (a-h,o-z)
      dimension a(ld),b(ld),c(ld),d(ld),v(ld),alef(ld),bet(ld)
      ub=1.d00/b(1)
      alef(1)=c(1)*ub
      bet(1)=d(1)*ub
      do 10 i=2,n
      l=i-1
      qz=b(i)-a(i)*alef(l)
      uqz=1.d00/qz
      alef(i)=c(i)*uqz
   10 bet(i)=(d(i)-a(i)*bet(l))*uqz
      nm1=n-1
      v(n)=bet(n)
      do 20 i=1,nm1
      ii=n-i
      l=ii+1
   20 v(ii)=bet(ii)-alef(ii)*v(l)
      return
      end
